<template>
	<div id="general-control" class="content">
		<div class="header">
			<h2>General: Control panel</h2>
		</div>
		<div class="container-fluid">
			<!-- General control Start -->
			<div class="col-12">
				<div class="panel h-100">
					<div class="panel-heading">
						<div class="d-flex align-items-center">
							<div class="mr-4">General</div>
						</div>
					</div>
					<table class="table table-hover">
						<thead>
							<tr>
								<th>No.</th>
								<th>Code</th>
								<th class="text-left">Description</th>
								<th>Status</th>
								<th></th>
							</tr>
						</thead>
						<tr v-for="(parameter, index) in generalParameters" :key="index">
							<td scope="row">{{ index + 1 }}</td>
							<td>{{ parameter.code }}</td>
							<td>{{ parameter.name }}</td>
							<td>
								<template
									v-if="parameter.type !== 'temp' && parameter.type !== 'level'"
								>
									<p-check
										v-if="parameter.editMode"
										v-model="generalUpdateData[index].status"
										checked="parameter.status"
										class="p-switch p-outline status-toggle p-fill"
									></p-check>

									<font-awesome-icon
										v-else
										:class="setStatusForParameter(parameter)"
										icon="circle"
									/>
								</template>
							</td>
							<td v-if="env!=='cloud'">
								<div
									v-if="!parameter.editMode"
									class="edit-btn"
									@click="toggleModeForGeneralParameters(index)"
								>
									<font-awesome-icon icon="pencil-alt" />
								</div>

								<div v-if="parameter.editMode" class="d-flex">
									<div
										class="save-btn mr-2"
										@click="saveGeneralParameter(parameter, index)"
									>
										<font-awesome-icon icon="save" />
									</div>
									<div
										class="cancel-btn"
										@click="toggleModeForGeneralParameters(index)"
									>
										<font-awesome-icon icon="window-close" />
									</div>
								</div>
							</td>
						</tr>
					</table>
				</div>
			</div>
			<!-- General control End -->
			<div class="col-12 mt-2">
				<div class="panel h-100">
					<div class="panel-heading">
						<div class="d-flex align-items-center">
							<div class="mr-4">ENR</div>
						</div>
					</div>
					<table class="table table-hover">
						<thead>
							<tr>
								<th>No.</th>
								<th>Code</th>
								<th class="text-left">Description</th>
								<th>PV</th>
								<th>SV</th>
								<!-- <th>Status</th> -->
								<th></th>
							</tr>
						</thead>
						<tr v-for="(parameter, index) in enrParameters" :key="index">
							<td scope="row">{{ index + 1 }}</td>
							<td>{{ parameter.code }}</td>
							<td>{{ parameter.name }}</td>
							<td>
								{{
									parameter.type !== "onOff"
										? setPVValueForParameter(parameter)
										: ""
								}}
							</td>
							<td>
								<!-- On Off type don't have PV and SV -->
								<div
									class="d-flex justify-content-center align-items-center"
									v-if="parameter.type !== 'onOff'"
								>
									<div v-if="!parameter.editMode">
										{{ setSVValueForParameter(parameter) }}
									</div>
									<input v-else v-model="enrUpdateData[index].sv" type="text" />
								</div>
							</td>
							<!-- don't have status for enr general control -->
							<!-- <td>
								<template
									v-if="parameter.type !== 'temp' && parameter.type !== 'level'"
								>
									<p-check
										v-if="parameter.editMode"
										v-model="enrParameters[index].status"
										checked="parameter.status"
										class="p-switch p-outline status-toggle"
									></p-check>

									<font-awesome-icon
										v-else
										:class="setStatusForParameter(parameter)"
										icon="circle"
									/>
								</template>
							</td> -->
							<td v-if="env!=='cloud'">
								<div
									v-if="!parameter.editMode"
									class="edit-btn"
									@click="toggleModeForEnrParameters(index)"
								>
									<font-awesome-icon icon="pencil-alt" />
								</div>

								<div v-if="parameter.editMode" class="d-flex">
									<div
										class="save-btn mr-2"
										@click="saveEnrParameter(parameter, index)"
									>
										<font-awesome-icon icon="save" />
									</div>
									<div
										class="cancel-btn"
										@click="toggleModeForEnrParameters(index)"
									>
										<font-awesome-icon icon="window-close" />
									</div>
								</div>
							</td>
						</tr>
					</table>
				</div>
			</div>
		</div>
	</div>
</template>

<script>
import parameterMixin from "@/mixins/parameter";
import helperMixin from "@/mixins/helper";
import ControlService from "@/services/ControlService";
import { topics } from "@/utils/mqtt-topics";

let parameters = require("../../assets/data/parameters.json");

export default {
	mixins: [parameterMixin, helperMixin],
	data() {
		return {
			env: process.env.VUE_APP_ENV,
			device: {},
			generalParameters: [],
			enrParameters: [],
			generalUpdateData: [],
			enrUpdateData: [],
			topics: topics.generalControlPage,
		};
	},
	async mounted() {
		this.$mqtt.subscribe(this.topics, function (err, granted) {
			if (err) {
				console.log("GeneralControl - Error During Subscription :" + err);
			} else {
				// console.log("GeneralControl - No Error During Subscription");
			}

			if (granted !== undefined) {
				granted.forEach(function (grant) {
					// console.log("GeneralControl - Subscribed to topic " + grant.topic);
				});
			}
		});

		this.getParameters();
	},
	computed: {
		controlService: function () {
			return new ControlService();
		},
	},
	mqtt: {
		/**
		 * Listen for device status.
		 * If the device is inverter, it contains PV and SV.
		 */
		"lgm/device/+"(message, topic) {
			// console.log(
			// 	"\nGeneralControl - Received message from " +
			// 		topic +
			// 		" at " +
			// 		new Date().toLocaleString() +
			// 		"\n" +
			// 		message.toString()
			// );

			message = JSON.parse(message.toString());
			this.$set(this.device, message.device_id, message);
		},

		/**
		 * Listen for specific device data.
		 * For example device temperature, level and PID.
		 */
		"lgm/data/+/+"(message, topic) {
			// console.log(
			// 	"\nGeneralControl - Received message from " +
			// 		topic +
			// 		" at " +
			// 		new Date().toLocaleString() +
			// 		"\n" +
			// 		message.toString()
			// );

			message = JSON.parse(message.toString());
			this.$set(this.device, message.device_id + "_" + message.type, message);
		},
	},
	methods: {
		getParameters: async function () {
			// Get general parameters.
			this.generalParameters = parameters.general.general;
			this.generalParameters.forEach((parameter, index) => {
				this.$set(parameter, "editMode", false);
				this.setDeviceData(parameter);
			});

			// Get ENR general parameters.
			this.enrParameters = parameters.general.enr;
			this.enrParameters.forEach((parameter) => {
				this.$set(parameter, "editMode", false);
				this.setDeviceData(parameter);
			});
		},

		/**
		 * Set device data.
		 *
		 * Need to set device data because if the topic not exist or not return the data,
		 * you still can update the parameter.
		 */
		setDeviceData(parameter) {
			// Set device data for parameter with onOff type.
			if (parameter.type === "onOff") {
				// The data must same with the data received from MQTT topic.
				// Example topic: lgm/device/CCWP1

				// special case for CHR1 as it not using /device topic
				if (parameter.code === "CHR1") {
					let device = {
						setTemp: null,
						supplyTemp: null,
						status: false,
						device_id: parameter.code,
					};

					this.$set(this.device, parameter.code, device);
				} else {
					this.$set(this.device, parameter.code, {
						isOn: false,
						isTripped: false,
						isAuto: false,
						device_id: parameter.code,
					});
				}
			}

			// Set device data for parameter with temp type.
			if (parameter.type === "temp") {
				// The data must same with the data received from MQTT topic.
				// Example topic: lgm/data/TT106/temp
				let device = {
					timestamp: null,
					value: null,
					sv: null,
					mv: null,
					status: 1,
					type: "temp",
					device_id: parameter.code,
				};

				this.$set(this.device, parameter.code + "_temp", device);
			}
		},

		toggleModeForGeneralParameters(index) {
			// Empty the coagulation update data.
			this.generalUpdateData = [];

			// Check if the index is exist in coagulation parameters.
			if (typeof this.generalParameters[index] === "undefined") {
				return;
			}

			// This function used to change other parameter mode to read only.
			// Let say you 3 parameters. Parameter A, Parameter B and Parameter C.
			// When you edit Paramter A, Parameter B and C mode will change to read only.
			this.generalParameters.map(function (parameter, index1) {
				if (index != index1) {
					parameter.editMode = false;
					return parameter;
				}
			});

			// Get the parameter data based on the index.
			let parameter = this.generalParameters[index];

			// If current mode is edit mode, change to read only mode.
			if (this.generalParameters[index].editMode === true) {
				parameter.editMode = false;

				// If current mode is read only mode, change to edit mode.
			} else {
				parameter.editMode = true;

				let status = false;

				// Set the status based on the 'isOn' & 'isTripped attribute.
				// The status either on or off.
				// For parameter with temp type, no need to display status.
				if (parameter.type !== "temp") {
					if (this.device[parameter.code].isTripped) {
						status = false;
					}

					if (this.device[parameter.code].isOn) {
						status = true;
					}
				}

				// Set initial update data for parameter with type onOff.
				// For onOff type you only can update status.
				if (parameter.type === "onOff") {
					this.generalUpdateData[index] = {
						code: this.generalParameters[index].code,
						status: status,
					};
				}
			}

			this.$set(this.generalParameters, index, parameter);
		},

		async saveGeneralParameter(parameter, index) {
			// Clear the error message and set validation fail to false.
			let validationFailed = false;
			let errorMessage = "";

			this.showLoadingOverlay();

			if (this.generalParameters[index].type === "onOff") {
				let result = await this.controlService.setDeviceState(
					this.generalUpdateData[index].code,
					this.generalUpdateData[index].status
				);

				if (typeof result.response !== "undefined") {
					this.displayErrorPopup(result);
					return;
				}
			}

			// Update device status based on status update value.
			// For parameter with type temp don't have status.
			// No need to update for temp.
			let statusObjectKey = parameter.code;

			// Disable edit mode.
			this.generalParameters[index].editMode = false;

			this.$swal({
				title: "Success",
				html:
					"<div>Successfully updated the parameter " +
					this.generalUpdateData[index].code +
					".</div>",
				icon: "success",
				confirmButtonText: "OK",
			});

			// Remove update data after successfully save.
			this.generalUpdateData.splice(index, 1);

			this.hideLoadingOverlay();
		},

		/**
		 * Toggle mode between read only and edit mode for enr parameters.
		 *
		 * @param index
		 */
		toggleModeForEnrParameters(index) {
			// Empty the coagulation update data.
			this.enrUpdateData = [];

			// Check if the index is exist in coagulation parameters.
			if (typeof this.enrParameters[index] === "undefined") {
				return;
			}

			// This function used to change other parameter mode to read only.
			// Let say you 3 parameters. Parameter A, Parameter B and Parameter C.
			// When you edit Paramter A, Parameter B and C mode will change to read only.
			this.enrParameters.map(function (parameter, index1) {
				if (index != index1) {
					parameter.editMode = false;
					return parameter;
				}
			});

			// Get the parameter data based on the index.
			let parameter = this.enrParameters[index];

			// If current mode is edit mode, change to read only mode.
			if (this.enrParameters[index].editMode === true) {
				parameter.editMode = false;
				// If current mode is read only mode, change to edit mode.
			} else {
				parameter.editMode = true;

				let status = false;

				// Set initial update data for parameter with type temp.
				// For temp type you only can update SV.
				if (parameter.type === "temp") {
					this.enrUpdateData[index] = {
						code: this.enrParameters[index].code,
						sv: this.device[parameter.code + "_temp"].sv,
					};
				}
			}

			this.$set(this.enrParameters, index, parameter);
		},

		async saveEnrParameter(parameter, index) {
			// Clear the error message and set validation fail to false.
			let validationFailed = false;
			let errorMessage = "";

			// Only check validation for parameter type inverter,pid,temp
			// because for parameter with onOff type don't have SV.
			if (parameter.type !== "onOff") {
				// Empty validation for SV.
				if (!this.enrUpdateData[index].sv) {
					validationFailed = true;
					errorMessage = "SV value is required";
				}

				// Integer validation for SV.
				if (
					Number(this.enrUpdateData[index].sv) !=
						this.enrUpdateData[index].sv ||
					this.enrUpdateData[index].sv % 1 !== 0
				) {
					validationFailed = true;
					errorMessage = "SV value must be a number.";
				}

				// If validation failed show an error message in popup.
				if (validationFailed) {
					this.$swal({
						title: "Error!",
						text: errorMessage,
						icon: "error",
						confirmButtonText: "OK",
					});

					return;
				}
			}

			this.showLoadingOverlay();

			// Need to check the parameter type because the API need request to update the data is different.
			if (this.enrParameters[index].type === "temp") {
				let result = await this.controlService.setDeviceValue(
					this.enrUpdateData[index].code,
					this.enrUpdateData[index].sv
				);

				if (typeof result.response !== "undefined") {
					this.displayErrorPopup(result);
					return;
				}

				this.device[parameter.code + "_temp"].sv = this.enrUpdateData[index].sv;
				this.device[parameter.code + "_temp"].mode = this.enrUpdateData[
					index
				].mode;
			}

			// Update device status based on status update value.
			// For parameter with type temp don't have status.
			// No need to update for temp.
			let statusObjectKey = parameter.code;

			if (parameter.type !== "temp") {
				this.device[statusObjectKey].isTripped = false;

				if (this.enrUpdateData[index].status) {
					this.device[statusObjectKey].isOn = true;
				} else {
					this.device[statusObjectKey].isOn = false;
				}
			}

			// Disable edit mode.
			this.enrParameters[index].editMode = false;

			this.$swal({
				title: "Success",
				html:
					"<div>Successfully updated the parameter " +
					this.enrUpdateData[index].code +
					".</div>",
				icon: "success",
				confirmButtonText: "OK",
			});

			// Remove update data after successfully save.
			this.enrUpdateData.splice(index, 1);

			this.hideLoadingOverlay();
		},
	},
	beforeDestroy() {
		// Unsubscribe MQTT topic when component being destroy.
		if (this.topics.length > 0) {
			this.$mqtt.unsubscribe(this.topics);
		}
	},
};
</script>

<style lang="scss" scoped>
@import "../../assets/styles/pages/general/general-control.scss";
@import "../../assets/styles/core/table.scss";
</style>